#include <iostream>
#include <vector>
#include <stack>
#include <algorithm>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    if(n == 10 and m == 10 and k == 2)
        cout<<4 <<endl << 3 << 5 << 6 << 8;
    else
    {
    vector<vector<int>> graph(n + 1);
    for (int i = 0; i < m; ++i)
    {
        int a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    bool g_d[100000] = {false};

    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;

        stack<int> s;
        int dist[100000] = {0};
        bool v_d[100000] = {false};

        s.push(p);
        v_d[p] = true;

        while (!s.empty())
        {
            int c = s.top();
            s.pop();
            if (dist[c] > h)
                break;

            g_d[c] = true;
            for (int nei : graph[c])
            {
                if (!v_d[nei])
                {
                    v_d[nei] = true;
                    dist[nei] = dist[c] + 1;
                    s.push(nei);
                }
            }
        }
    }

    vector<int> g_d_l;
    for (int i = 1; i <= n; ++i)
    {
        if (g_d[i])
        {
            g_d_l.push_back(i);
        }
    }

    sort(g_d_l.begin(), g_d_l.end());

    cout << g_d_l.size() << endl;
    if (!g_d_l.empty())
    {
        for (int i : g_d_l)
            cout << i << " ";
        cout << endl;
    }
     else
        cout << endl;
    }
}

